<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PaycheckPaySummaryList StructType
 * @subpackage Structs
 */
class PaycheckPaySummaryList extends AbstractStructBase
{
    /**
     * The paycheckPaySummary
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\PaycheckPaySummary[]
     */
    public $paycheckPaySummary;
    /**
     * The replaceAll
     * Meta information extracted from the WSDL
     * - default: true
     * @var bool
     */
    public $replaceAll;
    /**
     * Constructor method for PaycheckPaySummaryList
     * @uses PaycheckPaySummaryList::setPaycheckPaySummary()
     * @uses PaycheckPaySummaryList::setReplaceAll()
     * @param \StructType\PaycheckPaySummary[] $paycheckPaySummary
     * @param bool $replaceAll
     */
    public function __construct(array $paycheckPaySummary = array(), $replaceAll = true)
    {
        $this
            ->setPaycheckPaySummary($paycheckPaySummary)
            ->setReplaceAll($replaceAll);
    }
    /**
     * Get paycheckPaySummary value
     * @return \StructType\PaycheckPaySummary[]|null
     */
    public function getPaycheckPaySummary()
    {
        return $this->paycheckPaySummary;
    }
    /**
     * This method is responsible for validating the values passed to the setPaycheckPaySummary method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPaycheckPaySummary method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePaycheckPaySummaryForArrayConstraintsFromSetPaycheckPaySummary(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $paycheckPaySummaryListPaycheckPaySummaryItem) {
            // validation for constraint: itemType
            if (!$paycheckPaySummaryListPaycheckPaySummaryItem instanceof \StructType\PaycheckPaySummary) {
                $invalidValues[] = is_object($paycheckPaySummaryListPaycheckPaySummaryItem) ? get_class($paycheckPaySummaryListPaycheckPaySummaryItem) : sprintf('%s(%s)', gettype($paycheckPaySummaryListPaycheckPaySummaryItem), var_export($paycheckPaySummaryListPaycheckPaySummaryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The paycheckPaySummary property can only contain items of type \StructType\PaycheckPaySummary, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set paycheckPaySummary value
     * @throws \InvalidArgumentException
     * @param \StructType\PaycheckPaySummary[] $paycheckPaySummary
     * @return \StructType\PaycheckPaySummaryList
     */
    public function setPaycheckPaySummary(array $paycheckPaySummary = array())
    {
        // validation for constraint: array
        if ('' !== ($paycheckPaySummaryArrayErrorMessage = self::validatePaycheckPaySummaryForArrayConstraintsFromSetPaycheckPaySummary($paycheckPaySummary))) {
            throw new \InvalidArgumentException($paycheckPaySummaryArrayErrorMessage, __LINE__);
        }
        $this->paycheckPaySummary = $paycheckPaySummary;
        return $this;
    }
    /**
     * Add item to paycheckPaySummary value
     * @throws \InvalidArgumentException
     * @param \StructType\PaycheckPaySummary $item
     * @return \StructType\PaycheckPaySummaryList
     */
    public function addToPaycheckPaySummary(\StructType\PaycheckPaySummary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PaycheckPaySummary) {
            throw new \InvalidArgumentException(sprintf('The paycheckPaySummary property can only contain items of type \StructType\PaycheckPaySummary, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->paycheckPaySummary[] = $item;
        return $this;
    }
    /**
     * Get replaceAll value
     * @return bool|null
     */
    public function getReplaceAll()
    {
        return $this->replaceAll;
    }
    /**
     * Set replaceAll value
     * @param bool $replaceAll
     * @return \StructType\PaycheckPaySummaryList
     */
    public function setReplaceAll($replaceAll = true)
    {
        // validation for constraint: boolean
        if (!is_null($replaceAll) && !is_bool($replaceAll)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replaceAll, true), gettype($replaceAll)), __LINE__);
        }
        $this->replaceAll = $replaceAll;
        return $this;
    }
}
